unit Main;

interface

uses
  WinTypes, WinProcs, Classes, Graphics, Forms, Controls,
  ColorDlg, StdCtrls, Menus, Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
    Shape1: TShape;
    ColorDialog1: TColorDialog;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    MainMenu1: TMainMenu;
    Shapes1: TMenuItem;
    ShapeColor1: TMenuItem;
    FormColor1: TMenuItem;
    Shapes2: TMenuItem;
    Rectangle1: TMenuItem;
    Square1: TMenuItem;
    RoundRect1: TMenuItem;
    RoundSquare1: TMenuItem;
    Ellipes1: TMenuItem;
    Circle1: TMenuItem;
    ExitItem: TMenuItem;
    procedure NewShapeClick(Sender: TObject);
    procedure ShapeColorClick(Sender: TObject);
    procedure FormColorClick(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.NewShapeClick(Sender: TObject);
begin
  Shape1.Shape := TShapeType((Sender as TMenuItem).Tag);
end;

procedure TForm1.ShapeColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
    Shape1.Brush.Color := ColorDialog1.Color;
end;

procedure TForm1.FormColorClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
    Form1.Color := ColorDialog1.Color;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  Shape1.Height := ScrollBar2.Position;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  Shape1.Width := ScrollBar1.Position;
end;

procedure TForm1.FormResize(Sender: TObject);
var
  Menu,
  Caption,
  Frame: Integer;
begin
  Caption := GetSystemMetrics(sm_cyCaption);
  Frame := GetSystemMetrics(sm_cxFrame) * 2;
  Menu := GetSystemMetrics(sm_cyMenu);
  Scrollbar1.Max := Width;
  Scrollbar2.Max := Height;
  Scrollbar2.Left := Width - Frame - Scrollbar2.Width;
  Scrollbar1.Top := Height - ScrollBar2.Width - Frame - Caption - Menu;
  Scrollbar1.Width := Width - Scrollbar2.Width - Frame;
  Scrollbar2.Height := Height - Frame - Caption - Menu - Scrollbar1.Height;
end;

procedure TForm1.ExitItemClick(Sender: TObject);
begin
  Close;
end;

end.

