unit Sta_unit;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DBTables, DB, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Table1: TTable;
    DataSource1: TDataSource;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Table1Name: TStringField;
    Table1Capital: TStringField;
    Table1Continent: TStringField;
    Table1Area: TFloatField;
    Table1Population: TFloatField;
    First: TButton;
    Last: TButton;
    Next: TButton;
    Prior: TButton;
    Insert: TButton;
    Append: TButton;
    Post: TButton;
    Cancel: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FirstClick(Sender: TObject);
    procedure LastClick(Sender: TObject);
    procedure NextClick(Sender: TObject);
    procedure PriorClick(Sender: TObject);
    procedure InsertClick(Sender: TObject);
    procedure AppendClick(Sender: TObject);
    procedure PostClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure DataSource1UpdateData(Sender: TObject);
    procedure DataSource1StateChange(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Edits: array[1..5] of TEdit;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  for i := 1 to 5 do
    Edits[i] := TEdit(FindComponent('Edit' + IntToStr(i)));
  Table1.Open;
end;

procedure TForm1.FirstClick(Sender: TObject);
begin
  Table1.First;
end;

procedure TForm1.LastClick(Sender: TObject);
begin
  Table1.Last;
end;

procedure TForm1.NextClick(Sender: TObject);
begin
  Table1.Next;
end;

procedure TForm1.PriorClick(Sender: TObject);
begin
  Table1.Prior;
end;

procedure TForm1.InsertClick(Sender: TObject);
begin
  Table1.Insert;
end;

procedure TForm1.AppendClick(Sender: TObject);
begin
  Table1.Append;
end;

procedure TForm1.PostClick(Sender: TObject);
begin
  Table1.Post;
end;

procedure TForm1.CancelClick(Sender: TObject);
begin
  Table1.Cancel;
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var
  i: Integer;
begin
  for i := 1 to 5 do
    Edits[i].Text := Table1.Fields[i - 1].AsString;
end;

procedure TForm1.DataSource1UpdateData(Sender: TObject);
var
  i: Integer;
begin
  for i := 1 to 5 do
    Table1.Fields[i - 1].AsString := Edits[i].Text;
end;

procedure TForm1.DataSource1StateChange(Sender: TObject);
var
  s : String;
begin
  case DataSource1.State of
    dsInactive : s:='Inactive';
    dsBrowse   : s:='Browse';
    dsEdit     : s:='Edit';
    dsInsert   : s:='Insert';
    dsSetKey   : s:='SetKey';
    dsCalcFields : s:='CalcFields';
  end;
  Label6.Caption:=s;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if DataSource1.State <> dsEdit then
    Table1.Edit;
end;

end.
